# Swagger\Client\JobDetailsApi

All URIs are relative to *https://service.fax-api.de/4.0/rest*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getJob**](JobDetailsApi.md#getjob) | **GET** /jobs/{id} | /jobs/{id}
[**getJobNotifications**](JobDetailsApi.md#getjobnotifications) | **GET** /jobs/{id}/notifications | /jobs/{id}/notifications
[**getJobPreviews**](JobDetailsApi.md#getjobpreviews) | **GET** /jobs/{id}/preview | /jobs/{id}/preview
[**getJobRecipients**](JobDetailsApi.md#getjobrecipients) | **GET** /jobs/{id}/recipients | /jobs/{id}/recipients
[**getJobTemplates**](JobDetailsApi.md#getjobtemplates) | **GET** /jobs/{id}/templates | /jobs/{id}/templates
[**putJob**](JobDetailsApi.md#putjob) | **PUT** /jobs/{id} | /jobs/{id}

# **getJob**
> \Swagger\Client\Model\Job getJob($id)

/jobs/{id}

Description: Obtain information of a specific job

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure API key authorization: ApiAuthKey
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('X-Auth-Token', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-Auth-Token', 'Bearer');

$apiInstance = new Swagger\Client\Api\JobDetailsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$id = "id_example"; // string | Identification number (UUID) of the job

try {
    $result = $apiInstance->getJob($id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling JobDetailsApi->getJob: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**| Identification number (UUID) of the job |

### Return type

[**\Swagger\Client\Model\Job**](../Model/Job.md)

### Authorization

[ApiAuthKey](../../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getJobNotifications**
> \Swagger\Client\Model\Notifications getJobNotifications($id)

/jobs/{id}/notifications

Description: To obtain a list of notifications to a specific job

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure API key authorization: ApiAuthKey
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('X-Auth-Token', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-Auth-Token', 'Bearer');

$apiInstance = new Swagger\Client\Api\JobDetailsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$id = "id_example"; // string | Identification number (UUID) of the job

try {
    $result = $apiInstance->getJobNotifications($id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling JobDetailsApi->getJobNotifications: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**| Identification number (UUID) of the job |

### Return type

[**\Swagger\Client\Model\Notifications**](../Model/Notifications.md)

### Authorization

[ApiAuthKey](../../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getJobPreviews**
> \Swagger\Client\Model\Preview getJobPreviews($id)

/jobs/{id}/preview

Description: To obtain the preview pdf document of a specific job

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure API key authorization: ApiAuthKey
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('X-Auth-Token', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-Auth-Token', 'Bearer');

$apiInstance = new Swagger\Client\Api\JobDetailsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$id = "id_example"; // string | Identification number (UUID) of the job

try {
    $result = $apiInstance->getJobPreviews($id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling JobDetailsApi->getJobPreviews: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**| Identification number (UUID) of the job |

### Return type

[**\Swagger\Client\Model\Preview**](../Model/Preview.md)

### Authorization

[ApiAuthKey](../../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getJobRecipients**
> \Swagger\Client\Model\JobRecipients getJobRecipients($id, $object_limit, $object_offset, $filter_fax_number, $filter_fax_number_norm, $filter_recipient_reference, $filter_international_dialing_code, $filter_result_code, $filter_result_text, $sort_field, $sort_order)

/jobs/{id}/recipients

Description: Resource to obtain a list of recipients to a specific job

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure API key authorization: ApiAuthKey
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('X-Auth-Token', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-Auth-Token', 'Bearer');

$apiInstance = new Swagger\Client\Api\JobDetailsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$id = "id_example"; // string | Identification number (UUID) of the job
$object_limit = 100; // int | Query parameter to change de default limitation of objects in the result data array
$object_offset = 0; // int | Query parameter to change de default offset of objects in the result data array
$filter_fax_number = "filter_fax_number_example"; // string | Query parameter to fetch recipients after his fax number
$filter_fax_number_norm = "filter_fax_number_norm_example"; // string | Query parameter to fetch recipients after his normed fax number
$filter_recipient_reference = "filter_recipient_reference_example"; // string | Query parameter to fetch recipients after his recipient reference
$filter_international_dialing_code = "filter_international_dialing_code_example"; // string | Query parameter to fetch recipients after his international dialing code
$filter_result_code = "filter_result_code_example"; // string | Query parameter to fetch recipients after his result code
$filter_result_text = "filter_result_text_example"; // string | Query parameter to fetch recipients after his result text
$sort_field = "sort_field_example"; // string | Available sort options for the result data array.
$sort_order = "asc"; // string | Describes the order for used sort fields

try {
    $result = $apiInstance->getJobRecipients($id, $object_limit, $object_offset, $filter_fax_number, $filter_fax_number_norm, $filter_recipient_reference, $filter_international_dialing_code, $filter_result_code, $filter_result_text, $sort_field, $sort_order);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling JobDetailsApi->getJobRecipients: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**| Identification number (UUID) of the job |
 **object_limit** | **int**| Query parameter to change de default limitation of objects in the result data array | [optional] [default to 100]
 **object_offset** | **int**| Query parameter to change de default offset of objects in the result data array | [optional] [default to 0]
 **filter_fax_number** | **string**| Query parameter to fetch recipients after his fax number | [optional]
 **filter_fax_number_norm** | **string**| Query parameter to fetch recipients after his normed fax number | [optional]
 **filter_recipient_reference** | **string**| Query parameter to fetch recipients after his recipient reference | [optional]
 **filter_international_dialing_code** | **string**| Query parameter to fetch recipients after his international dialing code | [optional]
 **filter_result_code** | **string**| Query parameter to fetch recipients after his result code | [optional]
 **filter_result_text** | **string**| Query parameter to fetch recipients after his result text | [optional]
 **sort_field** | **string**| Available sort options for the result data array. | [optional]
 **sort_order** | **string**| Describes the order for used sort fields | [optional] [default to asc]

### Return type

[**\Swagger\Client\Model\JobRecipients**](../Model/JobRecipients.md)

### Authorization

[ApiAuthKey](../../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getJobTemplates**
> \Swagger\Client\Model\Templates getJobTemplates($id)

/jobs/{id}/templates

Description: To obtain a list of template documents to a specific job

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure API key authorization: ApiAuthKey
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('X-Auth-Token', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-Auth-Token', 'Bearer');

$apiInstance = new Swagger\Client\Api\JobDetailsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$id = "id_example"; // string | Identification number (UUID) of the job

try {
    $result = $apiInstance->getJobTemplates($id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling JobDetailsApi->getJobTemplates: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**| Identification number (UUID) of the job |

### Return type

[**\Swagger\Client\Model\Templates**](../Model/Templates.md)

### Authorization

[ApiAuthKey](../../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **putJob**
> \Swagger\Client\Model\Job putJob($body, $id)

/jobs/{id}

Description: Control the transmission of the specific job

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure API key authorization: ApiAuthKey
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('X-Auth-Token', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-Auth-Token', 'Bearer');

$apiInstance = new Swagger\Client\Api\JobDetailsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$body = new \Swagger\Client\Model\JobsIdBody(); // \Swagger\Client\Model\JobsIdBody | Describes the required request body to perform an action on the fax job
$id = "id_example"; // string | Identification number (UUID) of the job

try {
    $result = $apiInstance->putJob($body, $id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling JobDetailsApi->putJob: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Swagger\Client\Model\JobsIdBody**](../Model/JobsIdBody.md)| Describes the required request body to perform an action on the fax job |
 **id** | **string**| Identification number (UUID) of the job |

### Return type

[**\Swagger\Client\Model\Job**](../Model/Job.md)

### Authorization

[ApiAuthKey](../../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

