<?php
/**
 * ErrorAuthenticationResponse
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Faxsuite RESTful API
 *
 * <p><img src=\"https://service.fax-api.de/4.0/img/fax-api.png\" height=\"100\" title=\"title\" /></p>  # API Definition <p><img src=\"https://service.fax-api.de/4.0/img/open_api.png\" height=\"50\" title=\"title\" /></p>  Die <b>RESTful API</b> basiert auf den <b>OpenAPI v3.0.3</b> Spezifikationen. OpenAPI Spezifikationen (OAS) definieren eine standardisierte und programmiersprachenunabhängige Schnittstellenbeschreibung für RESTful APIs. Diese Schnittstelle ist nutzbar ohne dass der Zugang zum Quellcode, zusätzliche Dokumentation oder die Untersuchung des Netzwerk-Traffics erforderlich ist. Somit kann ein Nutzer den Dienst mit einem Minimum an Implementierungslogik verstehen, mit ihm interagieren und einfach und schnell als API-Schnittstelle in seine eigene Softwareanwendung integrieren..<br><br>Weitere Informationen zu OpenAPI finden sie hier: <a href=\"https://www.openapis.org/\"><b>https://www.openapis.org/</b></a>   # Einleitung  <p><img src=\"https://service.fax-api.de/4.0/img/fax-api-faxsuite_v2.png\" height=\"350\" title=\"title\" />  </p>  Mit unserer <b>Faxsuite</b> können Sie überall und zu jederzeit Faxe senden und empfangen. Neben vielen anderen Funktionalitäten bietet Ihnen unsere <b>Faxsuite</b> auch eine RESTFul API-Schnittstelle. Damit können Sie z. B. aus Ihrer eigenen Softwareanwendung Faxe automatisiert versenden. Zeitintensive und teure Investionen in Hardware und Software gehören der Vergangenheit an und sind nicht mehr notwendig..<br><br>Um den API Service nutzen zu können, müssen Sie sich für die <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a> anmelden. Ein kostenloser Testzugang kann <a href=\"https://www.faxverteiler.com/testzugang/\"><b>hier</b></a> beantragt werden. (<i>To use the API service you need to sign up for the <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a>. A free trial access can be requested <a href=\"https://www.faxverteiler.com/testzugang/\"><b>here</b></a></i>).<br><br>Mit der <b>Faxsuite</b> haben Sie die Kontrolle über Ihre Fax-Kampangen. Mit dem kostenlosen Testzugang können Sie alle Faxsuite Module (Fax-API, Mail2Fax, Faxdrucker, Faxmailing und Faxempfang) unverbindlich ausprobieren. Sie bekommen 10 kostenlose Faxseiten, die Sie zum aktiven Kennenlernen unserer Faxsuite nutzen können. (<i>You can test the <b>Faxsuite</b> modules for four weeks without obligation. You will receive 10 free fax pages with the free trial access</i>)<br><br>Nachdem Sie den Zugang beantragt haben, können Sie sich <a href=\"https://www.faxsuite.de/\"><b>hier</b></a> in die <b>Faxsuite</b> einloggen. Unter dem Menüpunkt 'FAX-API | Konto verwalten' können Sie ein neues Fax-API Konto erstellen. Bei der Erstellung des Fax-API Kontos wird automatisch ein Autorisierungs-Schlüssel generiert, welchen Sie für den Zugang zur API-Schnittstelle benötigen. (<i>After creating a login you can access the <b>Faxsuite</b> <a href=\"https://www.faxsuite.de/\"><b>here</b></a>. In the menu 'FAX-API | Konto verwalten' you can create a new API-Account and receive the related token/key you need to gain access to our API service</i>).<br><br>Die standardisierte API Dokumentation wird Ihnen in zwei unterschiedlichen, als nicht <b>interaktive</b> und <b>interaktive</b> Varinaten angeboten:  |Name|Type|Link| |-----|-----|-------| | <b>Redoc</b> | non interactive | <b><a href=\"https://service.fax-api.de/4.0/rest/index.html\">click here for redoc</a></b> | <b>Swagger UI</b> | interactive (self hosted) | <b><a href=\"https://service.fax-api.de/4.0/rest/swagger-ui/index.html\">click here for swagger</a></b> |
 *
 * OpenAPI spec version: 4.0.0
 * Contact: support@fax-api.de
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.35
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;
use \Swagger\Client\ObjectSerializer;

/**
 * ErrorAuthenticationResponse Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class ErrorAuthenticationResponse implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'ErrorAuthenticationResponse';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'code' => 'int',
'title' => 'string',
'status' => 'int',
'detail' => 'string',
'instance' => 'string'    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'code' => null,
'title' => null,
'status' => null,
'detail' => null,
'instance' => null    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'code' => 'code',
'title' => 'title',
'status' => 'status',
'detail' => 'detail',
'instance' => 'instance'    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'code' => 'setCode',
'title' => 'setTitle',
'status' => 'setStatus',
'detail' => 'setDetail',
'instance' => 'setInstance'    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'code' => 'getCode',
'title' => 'getTitle',
'status' => 'getStatus',
'detail' => 'getDetail',
'instance' => 'getInstance'    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['code'] = isset($data['code']) ? $data['code'] : null;
        $this->container['title'] = isset($data['title']) ? $data['title'] : null;
        $this->container['status'] = isset($data['status']) ? $data['status'] : null;
        $this->container['detail'] = isset($data['detail']) ? $data['detail'] : null;
        $this->container['instance'] = isset($data['instance']) ? $data['instance'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets code
     *
     * @return int
     */
    public function getCode()
    {
        return $this->container['code'];
    }

    /**
     * Sets code
     *
     * @param int $code Error code number. Please see here for further information: <a href=\"https://hilfe.faxverteiler.com/ergebnis-code/\"><b>https://hilfe.faxverteiler.com/ergebnis-code/</b></a>
     *
     * @return $this
     */
    public function setCode($code)
    {
        $this->container['code'] = $code;

        return $this;
    }

    /**
     * Gets title
     *
     * @return string
     */
    public function getTitle()
    {
        return $this->container['title'];
    }

    /**
     * Sets title
     *
     * @param string $title Short error description
     *
     * @return $this
     */
    public function setTitle($title)
    {
        $this->container['title'] = $title;

        return $this;
    }

    /**
     * Gets status
     *
     * @return int
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param int $status HTTP error code
     *
     * @return $this
     */
    public function setStatus($status)
    {
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets detail
     *
     * @return string
     */
    public function getDetail()
    {
        return $this->container['detail'];
    }

    /**
     * Sets detail
     *
     * @param string $detail Detailed error description
     *
     * @return $this
     */
    public function setDetail($detail)
    {
        $this->container['detail'] = $detail;

        return $this;
    }

    /**
     * Gets instance
     *
     * @return string
     */
    public function getInstance()
    {
        return $this->container['instance'];
    }

    /**
     * Sets instance
     *
     * @param string $instance A URI reference that identifies the specific occurrence of the problem
     *
     * @return $this
     */
    public function setInstance($instance)
    {
        $this->container['instance'] = $instance;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}
